defmodule Cryptocurrency.MixProject do
  use Mix.Project

  @description """
    An Elixir library for validating Bitcoin, Ethereum, Litecoin, and other popular cryptocurrency addresses.
  """

  def project do
    [
      app: :cryptocurrency,
      version: "0.1.0",
      elixir: "~> 1.7",
      elixirc_paths: elixirc_paths(Mix.env()),
      start_permanent: Mix.env() == :prod,
      name: "Cryptocurrency",
      description: @description,
      package: package(),
      deps: deps(),
      source_url: "https://github.com/akrisanov/cryptocurrency",
      test_coverage: [tool: ExCoveralls],
      preferred_cli_env: [
        coveralls: :test,
        "coveralls.detail": :test,
        "coveralls.post": :test,
        "coveralls.html": :test
      ]
    ]
  end

  # Run "mix help compile.app" to learn about applications.
  def application do
    [
      extra_applications: [:logger]
    ]
  end

  # Specifies which paths to compile per environment.
  defp elixirc_paths(:test), do: ["lib", "test/support/"]
  defp elixirc_paths(_), do: ["lib"]

  # Run "mix help deps" to learn about dependencies.
  defp deps do
    [
      {:nimble_parsec, "~> 0.4.0", only: :dev},
      {:ex_doc, "~> 0.19.1", only: :dev},
      {:junit_formatter, "~> 3.0", only: :test},
      {:excoveralls, "~> 0.10", only: :test}
    ]
  end

  defp package do
    [
      maintainers: ["Andrey Krisanov"],
      licenses: ["MIT"],
      links: %{
        "Changelog" => "https://github.com/akrisanov/cryptocurrency/blob/master/CHANGELOG.md",
        "GitHub" => "https://github.com/akrisanov/cryptocurrency"
      }
    ]
  end
end
